// This file is generated by kconfig_compiler_kf6 from kllmcoresettings.kcfg.
// All changes you do to this file will be lost.
#ifndef KLLMCORESETTINGS_H
#define KLLMCORESETTINGS_H

#include "kllmcore_export.h"

#include <kconfigskeleton.h>
#include <QCoreApplication>
#include <QDebug>

#include <KUser>
#include <QEventLoop>
#include <KLLMInterface.h>
#include <KLLMConstants.h>

class KLLMCORE_EXPORT KLLMCoreSettings : public KConfigSkeleton
{
  Q_OBJECT
  public:

    static KLLMCoreSettings *self();
    ~KLLMCoreSettings() override;

    /**
      Set The URL to the Ollama instance
    */
    static
    void setServerUrl( const QUrl & v )
    {
      if (v != self()->mServerUrl && !self()->isServerUrlImmutable()) {
        self()->mServerUrl = v;
        Q_EMIT self()->ServerUrlChanged();
      }
    }

    Q_PROPERTY(QUrl serverUrl READ serverUrl WRITE setServerUrl NOTIFY ServerUrlChanged)
    Q_PROPERTY(bool isServerUrlImmutable READ isServerUrlImmutable CONSTANT)
    /**
      Get The URL to the Ollama instance
    */
    static
    QUrl serverUrl()
    {
      return self()->mServerUrl;
    }

    /**
      Is The URL to the Ollama instance Immutable
    */
    static
    bool isServerUrlImmutable()
    {
      return self()->isImmutable( QStringLiteral( "ServerUrl" ) );
    }

    /**
      Get The URL to the Ollama instance default value
    */
    static
    QUrl defaultServerUrlValue()
    {
        return defaultServerUrlValue_helper();
    }

    /**
      Set The system prompt for the LLM
    */
    static
    void setSystemPrompt( const QString & v )
    {
      if (v != self()->mSystemPrompt && !self()->isSystemPromptImmutable()) {
        self()->mSystemPrompt = v;
        Q_EMIT self()->SystemPromptChanged();
      }
    }

    Q_PROPERTY(QString systemPrompt READ systemPrompt WRITE setSystemPrompt NOTIFY SystemPromptChanged)
    Q_PROPERTY(bool isSystemPromptImmutable READ isSystemPromptImmutable CONSTANT)
    /**
      Get The system prompt for the LLM
    */
    static
    QString systemPrompt()
    {
      return self()->mSystemPrompt;
    }

    /**
      Is The system prompt for the LLM Immutable
    */
    static
    bool isSystemPromptImmutable()
    {
      return self()->isImmutable( QStringLiteral( "SystemPrompt" ) );
    }

    /**
      Get The system prompt for the LLM default value
    */
    static
    QString defaultSystemPromptValue()
    {
        return defaultSystemPromptValue_helper();
    }

    /**
      Set The model used to generate responses
    */
    static
    void setModel( const QString & v )
    {
      if (v != self()->mModel && !self()->isModelImmutable()) {
        self()->mModel = v;
        Q_EMIT self()->ModelChanged();
      }
    }

    Q_PROPERTY(QString model READ model WRITE setModel NOTIFY ModelChanged)
    Q_PROPERTY(bool isModelImmutable READ isModelImmutable CONSTANT)
    /**
      Get The model used to generate responses
    */
    static
    QString model()
    {
      return self()->mModel;
    }

    /**
      Is The model used to generate responses Immutable
    */
    static
    bool isModelImmutable()
    {
      return self()->isImmutable( QStringLiteral( "Model" ) );
    }

    /**
      Set Show debug information
    */
    static
    void setShowDebugInfo( bool v )
    {
      if (v != self()->mShowDebugInfo && !self()->isShowDebugInfoImmutable()) {
        self()->mShowDebugInfo = v;
        Q_EMIT self()->ShowDebugInfoChanged();
      }
    }

    Q_PROPERTY(bool showDebugInfo READ showDebugInfo WRITE setShowDebugInfo NOTIFY ShowDebugInfoChanged)
    Q_PROPERTY(bool isShowDebugInfoImmutable READ isShowDebugInfoImmutable CONSTANT)
    /**
      Get Show debug information
    */
    static
    bool showDebugInfo()
    {
      return self()->mShowDebugInfo;
    }

    /**
      Is Show debug information Immutable
    */
    static
    bool isShowDebugInfoImmutable()
    {
      return self()->isImmutable( QStringLiteral( "ShowDebugInfo" ) );
    }

    /**
      Get Show debug information default value
    */
    static
    bool defaultShowDebugInfoValue()
    {
        return defaultShowDebugInfoValue_helper();
    }

    /**
      Set Close Alpaka to system tray
    */
    static
    void setSystemTray( bool v )
    {
      if (v != self()->mSystemTray && !self()->isSystemTrayImmutable()) {
        self()->mSystemTray = v;
        Q_EMIT self()->SystemTrayChanged();
      }
    }

    Q_PROPERTY(bool systemTray READ systemTray WRITE setSystemTray NOTIFY SystemTrayChanged)
    Q_PROPERTY(bool isSystemTrayImmutable READ isSystemTrayImmutable CONSTANT)
    /**
      Get Close Alpaka to system tray
    */
    static
    bool systemTray()
    {
      return self()->mSystemTray;
    }

    /**
      Is Close Alpaka to system tray Immutable
    */
    static
    bool isSystemTrayImmutable()
    {
      return self()->isImmutable( QStringLiteral( "SystemTray" ) );
    }

    /**
      Get Close Alpaka to system tray default value
    */
    static
    bool defaultSystemTrayValue()
    {
        return defaultSystemTrayValue_helper();
    }


    enum {
      signalServerUrlChanged = 1,
      signalSystemPromptChanged = 2,
      signalModelChanged = 3,
      signalShowDebugInfoChanged = 4,
      signalSystemTrayChanged = 5
    };

  Q_SIGNALS:
    void ServerUrlChanged();

    void SystemPromptChanged();

    void ModelChanged();

    void ShowDebugInfoChanged();

    void SystemTrayChanged();

  private:
    void itemChanged(quint64 signalFlag);

  protected:
    KLLMCoreSettings();
    friend class KLLMCoreSettingsHelper;


    // Ollama
    QUrl mServerUrl;
    static QUrl defaultServerUrlValue_helper();

    // LLM
    QString mSystemPrompt;
    static QString defaultSystemPromptValue_helper();
    QString mModel;
    static QString defaultModelValue_helper();
    bool mShowDebugInfo;
    static bool defaultShowDebugInfoValue_helper();

    // General
    bool mSystemTray;
    static bool defaultSystemTrayValue_helper();

  private:
};

#endif

